trigger:
  branches:
    include:
    - main
    - development
    - release/*
    exclude:
      - feature/*

variables:
- name: AZURE_SUBSCRIPTION
  value: 'FestPay.Hml.Back.Checkout.Api'
- name: APP_TYPE
  value: 'webApp'
- name: buildConfiguration
  value: 'Release'
- name: sourceSolution
  value: 'ASA.FestPay.Transaction.Api.sln'

stages:
  - stage: build
    jobs:
      - job: build
        displayName: Build
        pool:
          vmImage: ubuntu-latest
        steps:
        - script: dotnet build $(sourceSolution) --configuration $(buildConfiguration)
          displayName: 'dotnet build $(buildConfiguration)'
        - task: ArchiveFiles@2
          displayName: 'Archive $(Build.ArtifactStagingDirectory)'
          inputs:
            rootFolderOrFile: '$(Build.Repository.LocalPath)'
            archiveFile: '$(Build.ArtifactStagingDirectory)/$(Build.BuildId).zip'
            includeRootFolder: false
        - task: PublishBuildArtifacts@1
          displayName: 'Publish Artifact: build'
          inputs:
            PathtoPublish: '$(Build.ArtifactStagingDirectory)/$(Build.BuildId).zip'
            ArtifactName: build
  - stage: hml
    dependsOn: build
    condition: and(succeeded('build'),or(startsWith(variables['Build.SourceBranch'], 'refs/heads/development'),startsWith(variables['Build.SourceBranch'], 'refs/heads/release')))
    jobs:
      - deployment: hml
        displayName: Deploy Hml
        environment: hml
        pool:
          vmImage: ubuntu-latest
        variables:
          - name: AZURE_SUBSCRIPTION
            value: 'FestPay.Hml.Back.Checkout.Api'
          - name: APP_NAME
            value: 'festpay-back-hml-api-checkout'
        strategy:
          runOnce:
            deploy:
              steps:
                - template: deployment-job.yml
  - stage: prd
    dependsOn: build
    condition: and(succeeded('build'), startsWith(variables['Build.SourceBranch'], 'refs/heads/main'))
    jobs:
      - deployment: prd
        displayName: Deploy Prd
        environment: prd
        pool:
          vmImage: ubuntu-latest
        variables:
          - name: AZURE_SUBSCRIPTION
            value: 'FestPay.Prod.Back.Checkout.Api'
          - name: APP_NAME
            value: 'festpay-back-prd-api-checkout'
        strategy:
          runOnce:
            deploy:
              steps:
                - template: deployment-job.yml